/* $Id: TopLevelS.C,v 1.6 1999/02/03 13:50:23 glgay Exp $ */
/*
 Copyright (C) 1993, 1994 Jettero Heller
 Copyright (C) 1994, 1995 Peter Williams
 
 This library is free software; you can redistribute it and/or
 modify it under the terms of the GNU Library General Public License 
 version 2 as published by the Free Software Foundation.

 This library is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 Library General Public License for more details.

 You should have received a copy of the GNU Library General Public
 License along with this library; see the file COPYING.  If not,
 write to the Free Software Foundation, Inc., 675 Mass Ave, 
 Cambridge, MA 02139, USA.
*/


/* Include(s): */
#include <Xarm/Shell.h>

/* TopLevelShellClass Members */
void 
TopLevelShellClass::realize() 
{ 
   XtRealizeWidget(widget()); 
}

void 
TopLevelShellClass::unrealize() 
{ 
   XtUnrealizeWidget(widget()); 
}

void 
TopLevelShellClass::iconic(Boolean cond)
{
   XtVaSetValues(widget(), XmNiconic, cond, NULL);
}

Boolean TopLevelShellClass::iconic() const
{
    Boolean b;

    XtVaGetValues(widget(), XmNiconic, &b, NULL);

    return b;
}

void
TopLevelShellClass::iconName(const _XtString str)
{
   /* notice no translation to XmString here */
   XtVaSetValues(widget(),XmNiconName,str, NULL);
}

void
TopLevelShellClass::iconNameEncoding(Atom eve)
{
   XtVaSetValues(widget(),XmNiconNameEncoding,eve, NULL);
}

TopLevelShell::TopLevelShell(Widget w_parent,
                             ArgList arglist,
                             Cardinal cnt,
                             _XtString name)
{
   Widget wid = createWidget(name, w_parent, arglist, cnt);
   widget(wid);
}

TopLevelShell::TopLevelShell(Widget w_parent, XarmArg &args, _XtString name)
{
   Widget wid = createWidget(name, w_parent, args.getArgs(), args.count());
   if (args.hasTypedArgs()) args.setTypedArgs(wid);
   widget(wid);
}

TopLevelShell::TopLevelShell(_XtString name, Widget w_parent)
{
   Widget wid = createWidget(name, w_parent);
   widget(wid);
}
